/* RoomModule.cc */
/* Edited by Sanshiro E. on 10 July 1998. */
/* Last updated by Sanshiro E. on 3 March 1999. */


#include <iostream.h>
#include "RoomModule.hh"


TModule::TModule(void)
{
}

TModule::~TModule()
{
}

int TModule::ModuleAddress(void)  throw(THardwareException)
{
    throw THardwareException(
        "TModule::ModuleAddress()", 
	"Inappropriate function called (internal error)"
    );

    return 0;
}

int TModule::Initialize(int InitialState) throw(THardwareException)
{
    return 0;
}

int TModule::Finalize(int FinalState) throw(THardwareException)
{
    return 0;
}

int TModule::Start(int Address) throw(THardwareException)
{
    throw THardwareException(
        "TModule::Start()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::Stop(int Address) throw(THardwareException)
{
    throw THardwareException(
        "TModule::Stop()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::IsRunning(int Address) throw(THardwareException)
{
    throw THardwareException(
        "TModule::IsRunning()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::IsBusy(int Address) throw(THardwareException)
{
    throw THardwareException(
        "TModule::IsBusy()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::Clear(int Address) throw(THardwareException)
{
    return 0;
}

int TModule::Read(int Address, int &Data)  throw(THardwareException)
{
    throw THardwareException(
        "TModule::Read()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::Write(int Address, int Data)  throw(THardwareException)
{
    throw THardwareException(
        "TModule::Write()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::BlockRead(int Address, void *Data, int MaxSize)  throw(THardwareException)
{
    throw THardwareException(
        "TModule::BlockRead()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::BlockWrite(int Address, const void *Data, int Size)  throw(THardwareException)
{
    throw THardwareException(
        "TModule::BlockWrite()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::SequencialRead(int Address, int Data[], int MaxSize) throw(THardwareException)
{
    int DataCount = 0;

    while ((DataCount < MaxSize) && (Read(Address, Data[DataCount]) > 0)) {
	DataCount++;
    }

    return DataCount;
}

int TModule::SequencialWrite(int Address, int Data[], int Size) throw(THardwareException)
{
    int DataCount = 0;

    while ((DataCount < Size) && (Write(Address, Data[DataCount]) > 0)) {
	DataCount++;
    }

    return DataCount;
}

int TModule::WaitData(unsigned TimeLimit) throw(THardwareException)
{
    unsigned Time = 0;
    int EventOccured;

    while (1) {
	EventOccured = HasData();
	if ((EventOccured) || (Time > TimeLimit)) {
	    break;
	}
	
	if (TimeLimit > 0) {
	    Time++;  // sec
	}
	Suspend(1, 0);
    }

    return EventOccured;
}

int TModule::HasData(int Address) throw(THardwareException)
{
    throw THardwareException(
        "TModule::HasData()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::GetData(int Address) throw(THardwareException)
{
    int Data;

    if (Read(Address, Data) != 1) {
	throw THardwareException("TModule::GetData()", "can't get data.");
    }

    return Data;
}

unsigned TModule::DataSize(void) throw(THardwareException)
{
    throw THardwareException(
        "TModule::DataSize()", 
	"This function is not supported for the module."
    );
}

int TModule::NumberOfChannels(void) throw(THardwareException)
{
    throw THardwareException(
        "TModule::NumberOfChannels()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::NumberOfSamples(void) throw(THardwareException)
{
    return 1;
}

int TModule::WriteRegister(int Address, int Data) throw(THardwareException)
{
     throw THardwareException(
        "TModule::WriteRegister()", 
	"This function is not supported for the module."
    );

     return 0;
}

int TModule::ReadRegister(int Address, int& Data) throw(THardwareException)
{
    throw THardwareException(
        "TModule::ReadRegister()", 
	"This function is not supported for the module."
    );
    
    return 0;
}

int TModule::EnableInterrupt(void) throw(THardwareException)
{
    throw THardwareException(
        "TModule::EnableInterrupt()", 
	"This function is not supported for the module."
    );

    return 0;
}

int TModule::DisableInterrupt(void) throw(THardwareException)
{
    throw THardwareException(
        "TModule::DisableInterrupt()", 
	"This function is not supported for the module."
    );

    return 0;
}
