/* RoomModule.hh */
/* Edited by Sanshiro E. on 10 July 1998. */
/* Last updated by Sanshiro E. on 9 June 2000. */


#ifndef __RoomModule_hh__
#define __RoomModule_hh__


#include <iostream.h>
#include "RoomDefs.hh"


class TInterruptHandler;

class TModule {
  protected:
    TModule(void);
  public:
    virtual ~TModule();
    virtual int ModuleAddress(void) throw(THardwareException);
    virtual int Initialize(int InitialState = 0) throw(THardwareException);
    virtual int Finalize(int FinalState = 0) throw(THardwareException);
    virtual int Start(int Address = -1) throw(THardwareException);
    virtual int Stop(int Address = -1) throw(THardwareException);
    virtual int IsRunning(int Address = -1) throw(THardwareException);
    virtual int IsBusy(int Address = -1) throw(THardwareException);
    virtual int Clear(int Address = -1) throw(THardwareException);
    virtual int Read(int Address, int &Data) throw(THardwareException);
    virtual int Write(int Address, int Data) throw(THardwareException);
    virtual int BlockRead(int Address, void *Data, int MaxSize) throw(THardwareException);
    virtual int BlockWrite(int Address, const void *Data, int Size) throw(THardwareException);
    virtual int SequencialRead(int Address, int Data[], int MaxSize) throw(THardwareException);
    virtual int SequencialWrite(int Address, int Data[], int Size) throw(THardwareException);
    virtual int WaitData(unsigned TimeLimit = 1 /* sec */) throw(THardwareException);
    virtual int HasData(int Address = -1) throw(THardwareException);
    virtual int GetData(int Address) throw(THardwareException);
    virtual unsigned DataSize(void) throw(THardwareException);
    virtual int NumberOfChannels(void) throw(THardwareException);
    virtual int NumberOfSamples(void) throw(THardwareException);
    virtual int WriteRegister(int Address, int Data) throw(THardwareException);
    virtual int ReadRegister(int Address, int& Data) throw(THardwareException);
    virtual int EnableInterrupt(void) throw(THardwareException);
    virtual int DisableInterrupt(void) throw(THardwareException);
};


#endif
