/* RoomTkoAccess.cc */
/* Edited by Sanshiro E. on 17 July 1999. */
/* Last updated by Sanshiro E. on 17 July 1999. */


#include "RoomTkoAccess.hh"


TTkoController::TTkoController(void) throw(THardwareException)
{
}

TTkoController::~TTkoController()
{
}


TTkoCrate::TTkoCrate(void)
{
    _TkoController = 0;
}

TTkoCrate::TTkoCrate(TTkoController *Controller)
{
    _TkoController = Controller;
}

TTkoCrate::~TTkoCrate()
{
}

void TTkoCrate::InstallController(TTkoController *Controller)
{
    _TkoController = Controller;    
}

void TTkoCrate::Install(TTkoModule *TkoModule, int ModuleAddress) throw(THardwareException)
{
    if (_TkoController == 0) {
        throw THardwareException(
            "TTkoCrate::Install()",
            "controller is not installed"
        );
    }

    TTkoModule::TModuleCookie Cookie;
    Cookie.TkoController = _TkoController;
    Cookie.TkoCrate = this;
    Cookie.ModuleAddress = ModuleAddress;
    
    TkoModule->Attach(Cookie);
    _ModuleList.push_back(TkoModule);
}

void TTkoCrate::Uninstall(TTkoModule *TkoModule)
{
    TkoModule->Detach();
}

TTkoModule::TTkoModule(void)
{
    _IsAttached = 0;
}

TTkoModule::~TTkoModule()
{
    if (_IsAttached) {
	_TkoCrate->Uninstall(this);
    }
}

int TTkoModule::ModuleAddress(void) throw(THardwareException)
{
    return _ModuleAddress;
}

int TTkoModule::TkoAction(int Address, int Function, int &Data, int &Q) 
{
    _TkoController->TkoAction(_ModuleAddress, Address, Function, Data, Q);
    
    return Q;
}

int TTkoModule::TkoAction(int Address, int Function, int &Data) throw(THardwareException)
{
    int Q;
    _TkoController->TkoAction(_ModuleAddress, Address, Function, Data, Q);

    return Q;
}

int TTkoModule::TkoAction(int Address, int Function) throw(THardwareException)
{
    int Data;
    int Q;
    _TkoController->TkoAction(_ModuleAddress, Address, Function, Data, Q);

    return Q;
}

void TTkoModule::Attach(const TModuleCookie &Cookie)
{
    _TkoController = Cookie.TkoController;
    _TkoCrate = Cookie.TkoCrate;
    _ModuleAddress = Cookie.ModuleAddress;
    _ModuleAddressBit = Bit(_ModuleAddress - 1);
    
    _IsAttached = 1;
}

void  TTkoModule::Detach()
{
    _IsAttached = 0;
}
