/* RoomTkoAccess.hh */
/* Edited by Sanshiro E. on 17 July 1999. */
/* Last updated by Sanshiro E. on 17 July 1999. */

#ifndef __RoomTkoAccess_hh__
#define __RoomTkoAccess_hh__


#include <vector>
#include "RoomDefs.hh"
#include "RoomDeviceBase.hh"
#include "RoomModule.hh"

class TTkoModule;


class TTkoController: public TController {
  public:
    TTkoController(void) throw(THardwareException);
    virtual ~TTkoController();
    virtual int TkoAction(int ModuleAddress, int Address, int Function, int &Data, int &Q) throw(THardwareException) = 0;
};


class TTkoCrate: public TCrate {
  public:
    TTkoCrate(void);
    TTkoCrate(TTkoController *Controller);
    virtual ~TTkoCrate();
    virtual void InstallController(TTkoController *Controller);
    virtual void Install(TTkoModule *TkoModule, int ModuleAddress) throw(THardwareException);
    virtual void Uninstall(TTkoModule *TkoModule);
  private:
    TTkoController *_TkoController;
    vector<TTkoModule*> _ModuleList;
};


class TTkoModule: public TModule {
  public:
    TTkoModule(void);
    virtual ~TTkoModule();
    virtual int ModuleAddress(void) throw(THardwareException);
  protected:
    int TkoAction(int Address, int Function, int &Data, int &Q);
    int TkoAction(int Address, int Function, int &Data) throw(THardwareException);
    int TkoAction(int Address, int Function) throw(THardwareException);
  private:
    friend void TTkoCrate::Install(TTkoModule *TkoModule, int ModuleAddress) throw(THardwareException);
    friend void TTkoCrate::Uninstall(TTkoModule *TkoModule);
    struct TModuleCookie{
	TTkoController *TkoController;
	TTkoCrate *TkoCrate;
	int ModuleAddress;
    };
    void Attach(const TModuleCookie &Cookie);
    void Detach(void);
    int _IsAttached;
  protected:
    TTkoController *_TkoController;
    TTkoCrate *_TkoCrate;
    int _ModuleAddress;
    unsigned _ModuleAddressBit;
};


#endif
