/* ioregtest.cc */
/* Edited by Sanshiro E. on 11 October 1997. */


#include "RoomVmeAccess.hh"
#include "RoomDeviceFactory.hh"
#include "module-VmeModules.hh"


int main(void)
{
    TDeviceFactory* DeviceFactory = TDeviceFactory::GetInstance();

    TVmeController* VmeController = DeviceFactory->CreateVmeController();
    TVmeCrate* VmeCrate = DeviceFactory->CreateVmeCrate();
    TVmeModule* IORegister = new TVmeIORegister_Rinei_RPV130();

    VmeCrate->InstallController(VmeController);
    VmeCrate->Install(IORegister, 0x8000, 3, 0xfff0);

    IORegister->Write(TVmeIORegister_Rinei_RPV130::wtPulse, Bit(4));

    delete IORegister;
    delete VmeCrate;
    delete VmeController;

    return 0;
}
